<template lang="pug">
	v-container(fluid)
		v-text-field(v-model='search' label='Rechercher des albums' prepend-icon='search' clearable @input='searchAlbums')
		v-row(dense)
			v-col(v-for='album in albums' :key='album.id' cols='3')
				PreviewAlbum(:album='album' searching @addAlbum='addAlbum')

		v-snackbar(v-model='snackbar' fixed center bottom color='error') Une erreur est survenue pendant la recherche, pensez bien à vérifier le token pour l'API Spotify
		
		v-tooltip(left)
			template(v-slot:activator='{ on, attrs }')
				v-btn(fab fixed bottom right color='primary' v-on='on' v-bind='attrs' @click="$router.push('/')")
					v-icon library_music
			| Ma Bibliothèque
</template>

<script>
import requests from "@/services/requests.js";
import PreviewAlbum from "@/components/PreviewAlbum";
export default {
	name: "Search",
	components: {
		PreviewAlbum,
	},
	data() {
		return {
			snackbar: false,
			search: "",
			searchTimeout: null,
			albums: [],
		};
	},
	methods: {
		searchAlbums() {
			// Timeout so the request is not sent everytime the input is changed, but after a small delay
			clearTimeout(this.searchTimeout);
			this.searchTimeout = setTimeout(this.searchAlbumsRequest, 400);
		},
		searchAlbumsRequest() {
			if (!this.search) {
				// If not query, there is no need to send a request
				this.albums = [];
				return;
			}
			// Call request to search for albums, if error, displays an error message
			requests.searchAlbums(this.search)
				.then((r) => {
					this.albums = r;
				})
				.catch(e => {
					this.snackbar = true;
				});
		},
		addAlbum(album) {
			// Add album to user library
			requests.addAlbum(this.$store.state.user, album);
		},
	},
};
</script>
